/*
 *
 * FIXME: I was wrong about this.  There are three possible lower DM pages.
 *
 *
 *  Here's how we lay out our Data Memory buffer...
 *
 *      Our map----------   2181-----------------------
 *      0x0000  -  0x1fff   0x2000  -  0x3fff DMOVLAY=0 (subtract 0x2000)
 *      0x2000  -  0x3fff   0x0000  -  0x1fff DMOVLAY=1 (add 0x2000)
 *      0x4000  -  0x5fff   0x0000  -  0x1fff DMOVLAY=2 (add 0x4000)
 *
 */

#include "sim.h"

void setdmfromreg(unsigned short addr, unsigned short *reg)
{
  if (reg)
    setdmword(addr, *reg);
  return;
}

void setregfromdm(unsigned short addr, unsigned short *reg)
{
  if (reg)
    *reg = getdmword(addr);
  return;
}

void setdmfromreg_indirect(unsigned int dag, unsigned int i, unsigned int m, unsigned short *reg)
{
  if (reg)
    setdmindirect(dag, i, m, *reg);
  else
    fprintf(stderr, "setdmfromreg_indirect: null arg!\n");
  return;
}

/*
 *
 *
 * FIXME: There may be some opcodes where the _B registers dont get
 * set, leaving this routine in an undefined state.
 */
void incdag(unsigned int dag, unsigned int i, unsigned int m)
{
  short14 *ireg,*mreg,*lreg,*breg;
  
  ireg = getdagregrgp_ptr(i, dag+1);
  mreg = getdagregrgp_ptr(m+4, dag+1);
  lreg = getdagregrgp_ptr(i+8, dag+1);
  breg = getdagregrgp_ptr(i, dag+4);

  if (!ireg || !mreg)
    {
      fprintf(stderr, "incdag: unknown i or m reg\n");
      return;
    }
  
  if (lreg->n == 0x0000)
    ireg->n += mreg->n;  /* all that bitfield stuff just so i could do this! */
  else
    {
      unsigned short i,l,b;
      i = (unsigned short)ireg->n; /* these are important! */
      l = (unsigned short)lreg->n;
      b = (unsigned short)breg->n;
      if (abs(mreg->n) >= l)
	{
	  fprintf(stderr, "setdmindirect: |m|<L condition failed!\n");
	  return;
	}
      /* from page 4-4 of manual...you think i figured this out myself? */
      ireg->n = (i + mreg->n - b) % l + b;
    }
  return;
}

short getdmindirect(unsigned int dag, unsigned int i, unsigned int m)
{
  short14 *ireg;
  short val;

  ireg = getdagregrgp_ptr(i, dag+1);
  
  if (!ireg)
    {
      fprintf(stderr, "setdmindirect: unknown i reg\n");
      return 0;
    }
  
  val = getdmword(((unsigned short)ireg->n)&0x3fff);
  incdag(dag, i, m);
  return val;
}

int setdmindirect(unsigned int dag, unsigned int i, unsigned int m, unsigned int val)
{
  short14 *ireg;

  ireg = getdagregrgp_ptr(i, dag+1);

  if (!ireg)
    {
      fprintf(stderr, "setdmindirect: unknown i reg\n");
      return 0;
    }
  
  setdmword(((unsigned short)ireg->n)&0x3fff, val);
  incdag(dag, i, m);

  return 1;
}

unsigned short getdmword(unsigned short addr)
{
  unsigned int baddr;
  
  if (addr >= 0x4000)
    fprintf(stderr, "getdmword: addr out of range\n");
  if (addr < 0x2000) /* in the paged area */
    {
      if (get_dmovlay() == 0x01) /* use 0x2000-0x3fff for 0x0000-0x1fff */
	baddr = (addr+0x2000)*2;
      else if (get_dmovlay() == 0x02) /* use 0x4000-5fff for 0x0000-0x1fff */
	baddr = (addr+0x4000)*2;
      else 
	return 0;
      return ((curdsp.dm[baddr]<<8)+curdsp.dm[baddr+1]);
    }
  else if (addr < 0x3fe0) /* in the standard nonpaged area */
    {
      baddr = (addr-0x2000)*2;
      return ((curdsp.dm[baddr]<<8)+curdsp.dm[baddr+1]);
    }
  else /* in the memory-mapped register region */
    return getmmapreg(addr);

  return 0;
}

void setdmword(unsigned short addr, unsigned short val)
{
  unsigned int baddr;

  if (addr >= 0x4000)
    {
      fprintf(stderr, "setdmword: addr out of range (%04x)\n", addr);
      return;
    }
  if (addr < 0x2000) /* in the paged area */
    {
      if (get_dmovlay() == 0x01) /* use 0x2000-0x3fff for 0x0000-0x1fff */
	baddr = (addr+0x2000)*2;
      else if (get_dmovlay() == 0x02) /* use 0x4000-5fff for 0x0000-0x1fff */
	baddr = (addr+0x4000)*2;
      else
	return;
      curdsp.dm[baddr] = (val>>8)&0xff;
      curdsp.dm[baddr+1] = val & 0xff;
      return;
    }
  else if (addr < 0x3fe0) /* in the standard nonpaged area */
    {
      baddr = (addr-0x2000)*2;
      curdsp.dm[baddr] = (val>>8)&0xff;
      curdsp.dm[baddr+2] = val & 0xff;
    }
  else /* in the memory-mapped register region */
    setmmapreg(addr, val);
  return;
}

int dmdump(unsigned short start, int len)
{
  int i;
  if ((start+len) >= 0x4000)
    {
      fprintf(stderr, "dmdump: start out of range\n");
      return -1;
    }

  fprintf(stderr, "---- Data Memory Dump (%04x to %04x) ----\n", start, start+len);
  if (start >= 0x2000) /* we're all in the stable page */
    {
      for (i=0; (i<len) && ((start+len)<0x6000); i++)
	{
	  fprintf(stderr, "0x%04x: %04x\n", start+i, getdmword(start+len));
	}
    }
  else
    {
      for (i=0; (i<len) && ((start+len)<0x6000); i++)
	{
	  fprintf(stderr, "0x%04x: %04x\n",start+i, getdmword(start+i));
	}
    }
  fprintf(stderr, "-----------------------------------------\n");
  /* FIXME: finish this */
  return -1;
}

void set_dmovlay(unsigned short new) { curdsp.memory_interface.dmovlay = new; }
unsigned short get_dmovlay(void) { return curdsp.memory_interface.dmovlay; }
