/*
 *
 *
 */

#include "sim.h"

int state_push(void)
{
  int cur;
  if (curdsp.sequencer.status_stack_len >= 16)
    {
      fprintf(stderr, "state_push: status stack overflow\n");
      curdsp.sequencer.sstat |= 0x20;
      return -1;
    }
  else if (curdsp.sequencer.sstat & 0x10)
    curdsp.sequencer.sstat ^= 0x10; /* unflag Empty */

  cur = curdsp.sequencer.status_stack_len;
  curdsp.sequencer.status_stack[cur].astat = curdsp.sequencer.astat;
  curdsp.sequencer.status_stack[cur].mstat = curdsp.sequencer.mstat;
  curdsp.sequencer.status_stack[cur].imask = curdsp.sequencer.imask;
  return ++curdsp.sequencer.status_stack_len;
}

void state_pop(void)
{
  int cur;
  if (!curdsp.sequencer.status_stack_len)
    return;
  cur = --curdsp.sequencer.status_stack_len;
  curdsp.sequencer.astat = curdsp.sequencer.status_stack[cur].astat;
  curdsp.sequencer.mstat = curdsp.sequencer.status_stack[cur].mstat;
  curdsp.sequencer.imask = curdsp.sequencer.status_stack[cur].imask;
  curdsp.sequencer.status_stack[cur].astat = 0x00;
  curdsp.sequencer.status_stack[cur].mstat = 0x00;
  curdsp.sequencer.status_stack[cur].imask = 0x000;
  
  if (!curdsp.sequencer.status_stack_len)
    curdsp.sequencer.sstat |= 0x10;
  return;
}

void state_dump(void)
{
  int i;
  fprintf(stderr, "state_dump: --- Status Stack (%2d of 16 filled) ---\n", curdsp.sequencer.status_stack_len);
  fprintf(stderr, "state_dump:\tastat = %02x\tmstat = %02x\timask = %03x\n", curdsp.sequencer.astat, curdsp.sequencer.mstat, curdsp.sequencer.imask);
  for (i=curdsp.sequencer.status_stack_len-1;i>=0;i--)
    fprintf(stderr, "state_dump:\t %2d\t%02x\t%02x\t%03x\n", i, 
	    curdsp.sequencer.status_stack[i].astat,
	    curdsp.sequencer.status_stack[i].mstat,
	    curdsp.sequencer.status_stack[i].imask);
  fprintf(stderr, "state_dump: --------------------------------------\n");
  return;
}

void state_zero(void)
{
  curdsp.sequencer.status_stack_len = 0;
  memset(curdsp.sequencer.status_stack, 0x00, sizeof(struct status_stack_entry_s)*16);
  return;
}
