/*
 *
 *
 *
 */

#include "sim.h"

unsigned char nextchar(int fd)
{
  unsigned char cur = 0x00;

  if (read(fd, &cur, 1) < 1)
    { /* we depend on the value of errno, dont do a perror! */
      return 0xff;
    }

  if ( (cur == 0x20) ||
       (cur == 0x0a) ||
       (cur == 0x0d) )
    return nextchar(fd);
  else
    return cur;
}

unsigned char fromhex(unsigned char arg)
{
  /* digits */
  if ( (arg >= 0x30) && (arg <= 0x39))
    return (arg-0x30);
  /* uppers */
  else if ((arg >= 0x41) && (arg <= 0x5a))
    return (arg-0x41)+0x0a;
  /* lowers */
  else if ((arg >= 0x61) && (arg <= 0x7a))
    return (arg-0x61)+0x0a;
  return 0;
}

unsigned char nextbyte(int fd)
{
  unsigned char ret;
  ret = fromhex(nextchar(fd)) << 4;
  ret += fromhex(nextchar(fd));
  return ret;
}

unsigned int nextword24(int fd)
{
  int i;
  unsigned int ret=0;
  unsigned char curb = 0x00;

  for (i=2;i>=0;i--)
    {
      curb = nextbyte(fd);
      ret += curb << (i*8);
    }
  return ret;
}

unsigned int glue24(unsigned char arg1, unsigned char arg2, unsigned char arg3)
{
  unsigned int ret = 0x000000;
  ret += arg1 << 16;
  ret += arg2 << 8;
  ret += arg3;
  return ret;
}

unsigned int glue16(unsigned char arg1, unsigned char arg2)
{
  unsigned int ret = 0x000000;
  ret += arg1 << 8;
  ret += arg2;
  return ret;
}
